---
variables:
  IMAGENAME: fapi 
  DEPLOYVER: "latest"

default:
  tags:
    - k3s
    - amd64
  image: registry.gitlab.com/wing00/containers/focal-base/gitlab-runner:latest 


stages:
  - build 

.buildahlogin_template: &buildah_login
  before_script: 
    - echo "$PATH"
    - sync
    - buildah --version
    - buildah login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - sed -i 's/driver = \"overlay\"/driver = \"vfs\"/g' /etc/containers/storage.conf

.container_artifact_policy:
  artifacts:
    name: $CI_JOB_NAME
    paths:
      - imagehash.txt
    when: always
    expire_in: 5 day

.build_setup:
  script:
    - buildah --version
    # Seupt to build container
    - container=$(buildah from scratch)
    - contmnt=$(buildah mount $container)
    - echo $contmnt
    - mkdir -p $contmnt/etc/apt
    # copy over registry keys
    - cp -r /etc/apt/trusted.gpg.d $contmnt/etc/apt/.
    # Install Ubuntu here
    - multistrap -f multistrap.config -d $contmnt
    - buildah run $container -- mkdir -p /app

.build_fapi:
  stage: build
  script:
    # Set entry point when you go to run the container 
    - buildah config --workingdir /app $container
    # Copy over code and stuff that app needs to work
    - cp -r *.md *.py requirements.txt $contmnt/app/.
    - buildah run $container -- python3 -m pip install -r requirements.txt 
    - buildah run $container -- apt clean
    - sync

.build_commit_push:
  script:
    - buildah config --arch amd64 $container
    - buildah config --label name=flask_api_basic $container
    - buildah config --author "DagoRed dagoredcode@gmail.com" $container
    - buildah commit $container $IMAGENAME:${DEPLOYVER}
    - imagehash=$(buildah images|grep $IMAGENAME|awk '{print $3}')
    - buildah push $imagehash $CI_REGISTRY_IMAGE/$IMAGENAME:${DEPLOYVER}
    - buildah rmi $imagehash
    - buildah rm $container

build_main:
  stage: build
  script:
    - !reference [.build_setup, script]
    - !reference [.build_fapi, script]
    - !reference [.build_commit_push, script]
  only:
    - main
<<: *buildah_login

build_branch:
  stage: build
  variables:
    DEPLOYVER: $CI_COMMIT_BRANCH
  script:
    - !reference [.build_setup, script]
    - !reference [.build_fapi, script]
    - !reference [.build_commit_push, script]
  except:
    - main
<<: *buildah_login
